<template>
  <div>
    <h4>{{ $t('player.raw_stats') }}</h4>
    <b-row>
      <!-- Coop -->
      <b-col lg="4" class="pb-4">
        <b-card :header="$t('coop.coop')">
          <table v-if="coop" class="table table-striped table-hover">
            <tbody>
              <tr>
                <th><input v-model="customKey" type="radio" checked name="customMetric" value="coop.gamePlayed"> {{ $t('player.games_played') }}</th>
                <td>{{ numberWithSpaces(coop.gamePlayed) }}</td>
              </tr>
              <tr>
                <th><input v-model="customKey" type="radio" name="customMetric" value="coop.gameWin"> {{ $t('player.games_won') }}</th>
                <td>{{ numberWithSpaces(coop.gameWin) }}</td>
              </tr>
              <tr>
                <th>{{ $t('player.games_lost') }}</th>
                <td>{{ numberWithSpaces(coop.gamePlayed - coop.gameWin) }}</td>
              </tr>
              <tr>
                <th>{{ $t('player.win_lose_ration') }}</th>
                <td>
                  {{ (coop.gameWin / (coop.gamePlayed - coop.gameWin)).toFixed(2) }}
                  ({{ (coop.gameWin * 100 / coop.gamePlayed).toFixed(2) }}%)
                </td>
              </tr>
              <tr>
                <th>{{ $t('player.time_in_battle') }}</th>
                <td>{{ numberWithSpaces(coop.totalBattleTime / 60 / 60 / 1000) }} {{ $t('player.hours') }}</td>
              </tr>
              <hr>
            </tbody>
          </table>
          <div v-else>
            {{ $t('coop.no_coop') }}
          </div>
        </b-card>
      </b-col>
      <!-- PvE -->
      <b-col lg="4" class="pb-4">
        <b-card :header="$t('pve.pve')">
          <table v-if="pve" class="table table-striped table-hover">
            <tbody>
              <tr>
                <th><input v-model="customKey" type="radio" name="customMetric" value="pve.gamePlayed"> {{ $t('player.games_played') }}</th>
                <td>{{ numberWithSpaces(pve.gamePlayed) }}</td>
              </tr>
              <tr>
                <th><input v-model="customKey" type="radio" name="customMetric" value="pve.attackLevel"> {{ $t('pve.attack_level') }}</th>
                <td>{{ numberWithSpaces(pve.attackLevel) }}</td>
              </tr>
              <tr>
                <th><input v-model="customKey" type="radio" name="customMetric" value="pve.defenceLevel"> {{ $t('pve.defence_level') }}</th>
                <td>{{ numberWithSpaces(pve.defenceLevel) }}</td>
              </tr>
              <hr>
              <tr>
                <th>{{ $t('pve.avg_mission_level') }}</th>
                <td>{{ averagePveLevel.toFixed(2) }}</td>
              </tr>
              <tr
                v-for="key in Object.keys((pve.missionLevels || {}))"
                :key="key"
              >
                <th>{{ $t('level') }}: {{ $t(`pve.levels.${key}`) }}</th>
                <td>{{ pve.missionLevels[key] }}</td>
              </tr>
            </tbody>
          </table>
          <div v-else>
            {{ $t('pve.no_pve') }}
          </div>
        </b-card>
      </b-col>
      <!-- PvP -->
      <b-col lg="4" class="pb-4">
        <b-card :header="$t('pvp.pvp')">
          <table v-if="pvp" class="table table-striped table-hover">
            <tbody>
              <tr>
                <th><input v-model="customKey" type="radio" name="customMetric" value="pvp.gamePlayed"> {{ $t('player.games_played') }}</th>
                <td>{{ numberWithSpaces(pvp.gamePlayed) }}</td>
              </tr>
              <tr>
                <th><input v-model="customKey" type="radio" name="customMetric" value="pvp.gameWin"> {{ $t('player.games_won') }}</th>
                <td>{{ numberWithSpaces(pvp.gameWin) }}</td>
              </tr>
              <tr>
                <th>{{ $t('player.games_lost') }}</th>
                <td>{{ numberWithSpaces(pvp.gamePlayed - pvp.gameWin) }}</td>
              </tr>
              <tr>
                <th>{{ $t('player.win_lose_ration') }}</th>
                <td>
                  {{ (pvp.gameWin / (pvp.gamePlayed - pvp.gameWin)).toFixed(2) }}
                  ({{ (pvp.gameWin * 100 / pvp.gamePlayed).toFixed(2) }}%)
                </td>
              </tr>
              <tr>
                <th>{{ $t('player.time_in_battle') }}</th>
                <td>{{ numberWithSpaces(pvp.totalBattleTime / 60 / 60 / 1000) }} {{ $t('player.hours') }}</td>
              </tr>
              <hr>
              <tr>
                <th><input v-model="customKey" type="radio" name="customMetric" value="pvp.totalKill"> {{ $t('pvp.kills_total') }}</th>
                <td>{{ numberWithSpaces(pvp.totalKill) }}</td>
              </tr>
              <tr>
                <th><input v-model="customKey" type="radio" name="customMetric" value="pvp.totalDeath"> {{ $t('pvp.deaths_total') }}</th>
                <td>{{ numberWithSpaces(pvp.totalDeath) }}</td>
              </tr>
              <tr>
                <th>{{ $t('pvp.kill_death_ratio') }}</th>
                <td>{{ (pvp.totalKill / pvp.totalDeath).toFixed(2) }}</td>
              </tr>
              <tr>
                <th>{{ $t('pvp.kills_per_battle') }}</th>
                <td>{{ (pvp.totalKill / pvp.gamePlayed).toFixed(2) }}</td>
              </tr>
              <tr>
                <th><input v-model="customKey" type="radio" name="customMetric" value="pvp.totalAssists"> {{ $t('pvp.assists_total') }}</th>
                <td>{{ numberWithSpaces(pvp.totalAssists) }}</td>
              </tr>
              <tr>
                <th>{{ $t('pvp.assist_death_ratio') }}</th>
                <td>{{ (pvp.totalAssists / pvp.totalDeath).toFixed(2) }}</td>
              </tr>
              <tr>
                <th>{{ $t('pvp.assist_per_battle') }}</th>
                <td>{{ (pvp.totalAssists / pvp.gamePlayed).toFixed(2) }}</td>
              </tr>
              <hr>
              <tr>
                <th><input v-model="customKey" type="radio" name="customMetric" value="pvp.totalDmgDone"> {{ $t('pvp.damage_total') }}</th>
                <td>{{ numberWithSpaces(pvp.totalDmgDone) }}</td>
              </tr>
              <tr>
                <th>{{ $t('pvp.damage_per_battle') }}</th>
                <td>{{ numberWithSpaces(pvp.totalDmgDone / pvp.gamePlayed) }}</td>
              </tr>
              <tr>
                <th><input v-model="customKey" type="radio" name="customMetric" value="pvp.totalHealingDone"> {{ $t('pvp.healing_total') }}</th>
                <td>{{ numberWithSpaces(pvp.totalHealingDone) }}</td>
              </tr>
              <tr>
                <th>{{ $t('pvp.healing_per_battle') }}</th>
                <td>{{ numberWithSpaces(pvp.totalHealingDone / pvp.gamePlayed) }}</td>
              </tr>
              <tr>
                <th><input v-model="customKey" type="radio" name="customMetric" value="pvp.totalVpDmgDone"> {{ $t('pvp.capture_points') }}</th>
                <td>{{ numberWithSpaces(pvp.totalVpDmgDone) }}</td>
              </tr>
              <tr>
                <th>{{ $t('pvp.capture_points_per_battle') }}</th>
                <td>{{ (pvp.totalVpDmgDone / pvp.gamePlayed).toFixed(2) }}</td>
              </tr>
            </tbody>
          </table>
          <div v-else>
            {{ $t('pvp.no_pvp') }}
          </div>
        </b-card>
      </b-col>
    </b-row>
  </div>
</template>

<script>
import { mapState, mapGetters, mapMutations } from 'vuex'
import { numberWithSpaces } from '@/lib/helpers'

export default {
  name: 'RawPlayerStats',
  computed: {
    ...mapState('player', [
      'player'
    ]),
    ...mapGetters('player', [
      'pve',
      'pvp',
      'coop'
    ]),
    customKey: {
      get () {
        return this.$store.state.player.customKey
      },
      set (value) {
        this.SET_CUSTOM_KEY(value)
      }
    },
    averagePveLevel () {
      let level = 0
      if (!this.pve.missionLevels) {
        return 0
      }
      const keys = Object.keys(this.pve.missionLevels)
      Object.keys(this.pve.missionLevels).forEach((key) => {
        level += this.pve.missionLevels[key]
      })
      return level / keys.length
    }
  },
  methods: {
    ...mapMutations('player', ['SET_CUSTOM_KEY']),
    numberWithSpaces
  }
}
</script>
